using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web.Mvc;

namespace AjaxDialogs.Models
{
	public class CreateEventViewModel
	{
		public EventCreate Create { get; set; }
		public EventInvite Invite { get; set; }

		#region Nested type: EventCreate

		public class EventCreate
		{
			[Required, StringLength(16)]
			public string Title { get; set; }

			[Required, StringLength(20)]
			public string Location { get; set; }

			[Required]
			public DateTime? Date { get; set; }
		}

		#endregion

		#region Nested type: EventInvite

		public class EventInvite
		{
			public IEnumerable<SelectListItem> AllFriends
			{
				get
				{
					return
						new Dictionary<int, string>
							{
								{1, "Homer Simpson"},
								{2, "Abraham Simpson"},
								{3, "Krusty the Clown"},
								{4, "Barney Gumble"},
								{5, "Ned Flanders"},
								{6, "Reverend Lovejoy"}
							}.Select(user => new SelectListItem {Value = user.Key.ToString(), Text = user.Value});
				}
			}

			[Required(ErrorMessage = "You must select at least one friend")]
			public IEnumerable<int> InvitedFriends { get; set; }

			public bool IsPublic { get; set; }
		}

		#endregion
	}
}